#!/usr/bin/python
import os, string#, TkTools,
import tkSimpleDialog, DlgEncryption, DlgDecryption, popen2
from Tkinter import *

class TFrmMain:
    def __init__(self, parent, arg):
        self.parent = parent
        self.arg = arg
# ------------ define Form ------------------        
        parent.title("IDBES-GUI, Lars Fischer 2002 ")
        self.FrmMain = Frame(parent)
        self.Priv = ""
        
# ------ create Menu---------------
        MnuMain = self.setupMenu(self.FrmMain, parent)
        parent.config(menu=MnuMain)
        if self.arg=="":
            self.FrmMain.pack(fill=BOTH, expand=1)
            FrmInput = Frame(self.FrmMain, relief= RAISED, border=2)
            Button(FrmInput, text= "Encrypt", command=self.encrypt, underline=0).pack(side=LEFT, padx=2)
            Button(FrmInput, text= "Decrypt", command=self.decrypt, underline=0).pack(side=LEFT)
            Button(FrmInput, text= "Quit", command=parent.quit, underline=0).pack(side=RIGHT, padx=10)
            FrmInput.pack(fill=X)
            
        self.Text = Text(self.FrmMain);
        self.Text.pack(fill=X)
        
        self.FrmMain.pack(fill=BOTH, expand=1)
    # __init__()

        # create the Menu
    def setupMenu(self, Form, parent):
        MnuMain = Menu(Form)
        # Main Menu
        MnuFile = Menu(MnuMain)
        MnuMain.add_cascade(label="File", menu=MnuFile, underline=0)
        
        MnuKGA = Menu(MnuMain)
        MnuEncrypt = Menu(MnuMain)
        MnuDecrypt = Menu(MnuMain)

        # if called with --KGA options, display only KGA menu,
        # else display only Encryption/Decryption menu
        if self.arg=="--KGA":
            parent.title("IDBES-GUI, KGA mode,     Lars Fischer 2002 ")
            MnuMain.add_cascade(label="KGA" , menu=MnuKGA, underline=0)
        else:
            parent.title("IDBES-GUI, User mode,      Lars Fischer 2002 ")
            # add to file Menu, if not in KGA-mode
            MnuFile.add_command(label="Encrypt ...", command=self.encrypt, underline=0)
            MnuFile.add_command(label="Decrypt ...", command=self.decrypt, underline=0)
            MnuFile.add_separator()
            
        #File Menu
        MnuFile.add_command(label="Quit", command=parent.quit, underline=0)
        #KGA
        MnuKGA.add_command(label="generate private Key ...", command=self.KGA_genPrivKey, underline=0)
        #Encrypt
        parent.bind("<Alt-KeyPress>", self.handleAltKeyEvent)
        return MnuMain
    # buidMenu()

    def KGA_genPrivKey(self):
        id = tkSimpleDialog.askstring("KGA","Your Identity:")
        # Output only on commandline
#        os.system("./IDBES_KGA "+id)
        out = os.popen("../IDBES_KGA.sh "+id);
        self.Text.insert("1.0", "<"+"-"*50+"\n")
        self.Text.insert("2.0", "Private key for <"+id+">:\n")
        c = 3
        for l in out.readlines():
            self.Text.insert(str(c)+".0", l)
            c +=1
        out.close()
        self.Text.insert(str(c)+".0", "-"*50+">\n")
    #of KGA_genPrivKey()
        

    def encrypt(self):
        d = DlgEncryption.DlgEncryption(self.parent)
        if d.success:
            fn = d.File.get()
            id = d.Recipient.get()
            # encrypt in both Modi, write to files with extension .0 and .1
            os.system("../IDBES_encrypt.sh 0 "+id+" "+fn+" "+fn+".0")
            os.system("../IDBES_encrypt.sh 1 "+id+" "+fn+" "+fn+".1")
            self.Text.insert("1.0", "<"+"-"*50+"\n")
            self.Text.insert("2.0","The encrypted files are "+fn+".0 and "+fn+".1 \n")
            self.Text.insert("3.0", "-"*50+">\n")
            self.Text.insert("4.0", "\n")
    # od encrypt()
        

    def decrypt(self):
        d = DlgDecryption.DlgDecryption(self.parent, self.Priv)
        if d.success:
            fn = string.strip(d.File.get())
            self.Priv = string.strip(d.Priv.get())

            out = os.popen("../IDBES_decrypt.sh "+self.Priv+" "+fn+" /dev/stdout")
            self.Text.insert("1.0","\n"+ "-"*50+"\n")
            c = 1
            for l in out.readlines():
                self.Text.insert(str(c)+".0", l)
                c += 1
            out.close()
    # of decrypt()

    def handleAltKeyEvent(self, event):
        if (string.lower(event.char) == 'e') and (self.arg==""):
            self.encrypt()
        elif (string.lower(event.char) == 'd') and (self.arg==""):
            self.decrypt()
        elif (string.lower(event.char) == 'g') and (self.arg=="--KGA"):
            self.KGA_genPrivKey()
        elif string.lower(event.char) == 'q':
            self.parent.quit()

    # of handleAltKeyEvent()


# kind of c-ish main():
if __name__=="__main__":
    if len(sys.argv) == 2:
        arg  = sys.argv[1]
    else:
        arg = ""

    root = Tk()
    root.minsize(600,400)
    # create MainForm as child of root
    FrmMain=TFrmMain(root, arg)
    # run application:
    root.mainloop()

